import csv
import numpy as np
from collections import Counter
from mittens import GloVe, Mittens
from sklearn.feature_extraction import stop_words
from sklearn.feature_extraction.text import CountVectorizer


def glove2dict(glove_filename):
    with open(glove_filename, encoding='utf-8') as f:
        reader = csv.reader(f, delimiter=' ', quoting=csv.QUOTE_NONE)
        embed = {line[0]: np.array(list(map(float, line[1:])))
                for line in reader}
    return embed
# Get the pretrqined model from https://nlp.stanford.edu/projects/glove
glove_path = "/content/drive/My Drive/DBpedia/GloVe/glove.6B.50d.txt"
pre_glove = glove2dict(glove_path)

# corpus data.en
word_en = []
with open("./data.en", "r") as lines:
  for sentence in lines:
    sentence = sentence.strip("\n")
    sentence = "<s> "+sentence+" </s>"
    for word in sentence.split(" "):
      if "'" in word:
        for t1 in word.split("'"):
          word_en.append(t1.lower())
      if "’" in word:
        for t1 in word.split("’"):
          word_en.append(t1.lower())
      if "–" in word:
        for t1 in word.split("–"):
          word_en.append(t1.lower())
      if "." in word:
        for t1 in word.split("."):
          word_en.append(t1.lower())
      if "/" in word:
        for t1 in word.split("/"):
          word_en.append(t1.lower())
      if "@" in word:
        for t1 in word.split("@"):
          word_en.append(t1.lower())
      if "!" in word:
        for t1 in word.split("!"):
          word_en.append(t1.lower())
      if "\\" in word:
        for t1 in word.split("\\"):
          word_en.append(t1.lower())
      else:
        word_en.append(word.strip(":").strip("\"").strip("»").strip("+").strip("?").replace("i̇",""))
# get voab form vocab.en
vocab_en = []
with open("./vocab.en", "r") as lines:
  for vocab in lines:
    vocab_en.append(vocab.strip())

oov = [token for token in word_en if token not in pre_glove.keys()]


corp_vocab = list(set(oov))
en_doc = [' '.join(word_en)]

